"""
Rotate forward back and saves pictures as ps and as a jpg.
Got a text box.  Need to add return reset and sending to a file.
Could keep the cursor in the text box.
"""

#from Tkinter import Tk, Canvas, BOTH
from Tkinter import *
from ttk import Frame, Button, Style
import numpy as np
import math
import Image
from nealParams import *


from toSpikeServe import spikeQueue


class Environment(Frame):
    wordsForward=[0x00000801, # start parse
                  0x0000080B, #move
                  0x00000808, #forward
                  0x0000080C] #period

    wordsBack=[0x00000801, # start parse
                  0x0000080B, #move
                  0x00000802, #back
                  0x0000080C] #period

    wordsLeft=[0x00000801, # start parse
               0x00000815, #turn
               0x0000080A, #left
               0x0000080C] #period

    wordsRight=[0x00000801, # start parse
                0x00000815, #turn
                0x0000080E, #right
                0x0000080C] #period

    numFiles = 0

    gotCommandFromSpinnaker = False


    direction = 0.0
    camera = np.array([150.0,300.0,0.0,1.0])
  
    pyrP1 = np.array([100,400,400,1.0]) 
    pyrP2 = np.array([300.0,400.0,400.0,1.0]) 
    pyrP3 = np.array([300.0,400.0,600.0,1.0])
    pyrP4 = np.array([100.0,400.0,600.0,1.0])
    pyrP5 = np.array([200.0,200.0,500.0,1.0])

    translationMatrix = np.array([[1.0,0.0,0.0,0.0],
                                  [0.0,1.0,0.0,0.0],
                                  [0.0,0.0,1.0,0.0],
                                  [0.0,0.0,0.0,1.0]])


    def __init__(self, parent):
        Frame.__init__(self, parent)   
         
        self.parent = parent        
        self.initUI()
        #self.fileIn = open ("cb2ToEnvPipe","rb")
        #self.fileOut = open ("cabot2Pipe","wb")

    def forward(self):
        self.toSpinQ.writeSentence(self.wordsForward,3)

    def back(self):
        self.toSpinQ.writeSentence(self.wordsBack,3)

    def left (self):
        self.toSpinQ.writeSentence(self.wordsLeft,3)

    def right (self):
        self.toSpinQ.writeSentence(self.wordsRight,3)

    def dumpJPG(self):
        self.canvas.postscript(file="file_name.ps", colormode='color')
        image = Image.open("file_name.ps")
        image.save("temp.jpg","JPEG")
        #self.canvas.save(file="temp.jpg")
            
        print "dumpJPG"

    def putTextInFile(self,text):
        file = open("test.txt","w")
        file.write(text)
        
        print text

    ##-- get actions from spinnaker stored in text files
    def readFromSpin(self):
        fileInName = "data/fromCABot2" + str(self.numFiles) + ".txt"
        
        try:
            self.fileIn = open (fileInName,"rt")
        except IOError, e:
            #print "file not yet created", e  #keep looking for a new file
            if self.gotCommandFromSpinnaker:
                print "act" , self.toSpinQ.ticksSent
                self.toSpinQ.addConditionalTicks(33)  #100/3 
            if SIM_LENGTH > self.toSpinQ.ticksSent:
                self.after(100,self.readFromSpin)
            return

        fileName = "data/fromCABot2" + str(self.numFiles) + ".txt"
        commandNum = self.fileIn.read()
        self.gotCommandFromSpinnaker = True
        if (commandNum == "0"):
            self.turnRight()
        elif (commandNum == "1"):
            self.turnLeft()
        elif (commandNum == "2"):
            self.moveForward()
        elif (commandNum == "3"):
            self.moveBack()
        else:
            print "bad action ", temp
            
        self.fileIn.close()
        self.numFiles = self.numFiles + 1
        self.after(100,self.readFromSpin)

    #-----Functions for drawing
    def reDraw(self):
        self.canvas.delete(self.triangle1)
        self.canvas.delete(self.triangle2)
        self.canvas.delete(self.triangle3)
        self.canvas.delete(self.triangle4)
        self.drawPyramid()
        

    def drawFace(self,point1,point2,point3,fc):
        #translate to camera = 0,0,0 coordinates
        p1 = point1-self.camera
        p2 = point2-self.camera
        p3 = point3-self.camera

        #rotate 
        p1 = np.dot(self.translationMatrix,p1)
        p2 = np.dot(self.translationMatrix,p2)
        p3 = np.dot(self.translationMatrix,p3)

        #print 'go', p1,p2,p3,self.camera


        #project onto camera
        if (p1[2] == 0) or (p2[2] == 0) or (p3[2] == 0):
            print 'ho', p1,p2
            return


        #project onto 2D
        fovealLength = 100 #this makes the triangles look odd at the edges.

        distP1 = fovealLength/p1[2]
        distP2 = fovealLength/p2[2]
        distP3 = fovealLength/p3[2]


        if (distP1 < 0) or (distP2 < 0) or (distP3 < 0):
            return

        distP1 = abs(distP1)
        distP2 = abs(distP2)
        distP3 = abs(distP3)

        p1 = p1*distP1
        p2 = p2*distP2
        p3 = p3*distP3
        
        #move to the centre of the picture
        offset = np.array([250,250,0,0])
        p1=p1 + offset
        p2=p2 + offset
        p3=p3 + offset

        points = [p1[0], p1[1],p2[0], p2[1], p3[0], p3[1]]

#        triangle = self.canvas.create_polygon(points, outline='red', 
        triangle = self.canvas.create_polygon(points, outline='black', 
                                              fill=fc, width=2)
        return triangle
        
    def drawPyramid(self):
        self.triangle1 = self.drawFace(self.pyrP1,self.pyrP2, self.pyrP5,
                                      'black')
        self.triangle2 = self.drawFace(self.pyrP2,self.pyrP3, self.pyrP5,
                                      'black')
#                                       'green')
        self.triangle3 = self.drawFace(self.pyrP3,self.pyrP4, self.pyrP5,
                                      'black')
#                                       'blue')
        self.triangle4 = self.drawFace(self.pyrP4,self.pyrP1, self.pyrP5,
                                      'black')
#                                       'yellow')
        
    def inside(self,newCamera):
        if (newCamera[0] >= self.pyrP1[0]) and (newCamera[0] <= self.pyrP3[0]) and (newCamera[2] >= self.pyrP1[2]) and (newCamera[2] <= self.pyrP3[2]):
            return True
        return False
        
    #-----Functions for moving
    def move (self, tempCamera,distance):
        tempCamera[2] += distance * math.cos(self.direction)
        tempCamera[0] += distance * -math.sin(self.direction)
        return tempCamera

    def moveForward(self):
        print "move forward"
        temp = np.array(self.camera)
        temp = self.move(temp,50)
        if self.inside(temp):
            print "bump"
            self.putTextInFile("bump")
            return
        self.camera = temp
        self.reDraw()
        #print self.direction, self.camera[0], self.camera[2]

    def moveBack(self):
        print "move back"
        temp = np.array(self.camera)
        temp = self.move(temp,-47)
        if self.inside(temp):
            print "bump"
            return
        self.camera = temp
        self.reDraw()


    def setRotation(self):
        self.translationMatrix[0,0] = math.cos(self.direction)
        self.translationMatrix[0,2] = math.sin(self.direction)
        self.translationMatrix[2,0] = -math.sin(self.direction)
        self.translationMatrix[2,2] = math.cos(self.direction)
        print self.direction 

    def turnRight (self):
        print "turn right"
        self.direction -= 0.19
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()

    def turnLeft (self):
        print "turn left"
        self.direction += 0.17
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()

    def reset(self):
        self.direction = 0.0
        self.camera = np.array([150.0,300.0,0.0,1.0])
        self.reDraw()


    def keyHandler(self,event):
        #print "keyhandler", repr(event.char)
        if (event.char == '\r'):
            text = self.editBox.get(1.0,END)
            self.editBox.delete(1.0,END)
            self.putTextInFile(text)

    def initUI(self):
        self.parent.title("Shapes")        
        self.pack(fill=BOTH, expand=1)

        self.canvas = Canvas(self)
            
        self.drawPyramid()
        self.canvas.pack(fill=BOTH, expand=1)

        quitButton = Button(self, text="Quit",
            command=self.quit)
        quitButton.place(x=0, y=0)

        forwardButton = Button(self, text="Forward", command=self.forward)
        forwardButton.place(x=70, y=0)
        backButton = Button(self, text="Back", command=self.back)
        backButton.place(x=140, y=0)
        leftButton = Button(self, text="Left", command=self.left)
        leftButton.place(x=210, y=0)
        rightButton = Button(self, text="Right", command=self.right)
        rightButton.place(x=280, y=0)
        resetButton = Button(self, text="Reset", command=self.reset)
        resetButton.place(x=350, y=0)
        printButton = Button(self, text="Print", command=self.dumpJPG)
        printButton.place(x=420, y=0)
        self.editBox = Text(self,height=1, width=50)
        self.editBox.place(x=0, y=25)
        self.editBox.bind("<Key>",self.keyHandler)

        printButton.after(1000,self.readFromSpin) #setup a timer callback

def main():
    root = Tk()
    ex = Environment(root)
    ex.toSpinQ = spikeQueue()
    #ex.toSpinQ.addConditionalTicks(5000)
    root.geometry("500x600+300+300")
    root.mainloop()  


if __name__ == '__main__':
    main()  
